// This may look like C, but it's really -*- C++ -*-

//=============================================================================
/**
 *  @file    ClientEngine.h
 *
 *  ClientEngine.h,v 1.1 2005/10/19 00:27:50 dai_y Exp
 *
 *  @author  Tim Bradley <bradley_t@ociweb.com>
 */
//=============================================================================

#ifndef CLIENT_ENGINE_H
#define CLIENT_ENGINE_H

#include "CSD_PT_TestInf_Export.h"
#include "tao/Intrusive_Ref_Count_Base_T.h"
#include "tao/Intrusive_Ref_Count_Handle_T.h"
#include "tao/Environment.h"
#include "ace/Synch.h"
#include "ace/CORBA_macros.h"


class ClientEngine;
typedef TAO_Intrusive_Ref_Count_Handle<ClientEngine> ClientEngine_Handle;


class CSD_PT_TestInf_Export ClientEngine : public TAO_Intrusive_Ref_Count_Base<ACE_SYNCH_MUTEX>
{
  public:

    ClientEngine();
    virtual ~ClientEngine();

    virtual bool execute(unsigned num_loops 
                         ACE_ENV_ARG_DECL) = 0;
};

#endif
