// -*- C++ -*-

// =================================================================
/**
 * @file Codeset.cpp
 *
 * Codeset.cpp,v 1.3 2005/11/03 17:38:45 ossama Exp
 *
 * @author Phil Mesnier <mesnier_p@ociweb.com>
 */
// =================================================================

#include "Codeset.h"
#include "Codeset_Manager_Factory.h"
#include "UTF8_Latin1_Factory.h"
#include "UTF16_BOM_Factory.h"

#include "ace/Dynamic_Service.h"


ACE_RCSID (Codeset, Codeset, "Codeset.cpp,v 1.3 2005/11/03 17:38:45 ossama Exp")

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

int
TAO_Codeset_Initializer::init (void)
{
  int result = 0;

  result += ACE_Service_Config::process_directive
    (ace_svc_desc_TAO_UTF8_Latin1_Factory);

  result += ACE_Service_Config::process_directive
    (ace_svc_desc_TAO_UTF16_BOM_Factory);

  TAO_Codeset_Manager_Factory *cmf = ACE_Dynamic_Service<TAO_Codeset_Manager_Factory>::instance("TAO_Codeset");

  if (cmf != 0)
    {
      return result;
    }

  result += ACE_Service_Config::process_directive
    (ace_svc_desc_TAO_Codeset_Manager_Factory,1); // force replacement
  return result;
}

TAO_END_VERSIONED_NAMESPACE_DECL
