// -*- C++ -*-

// ===================================================================
/**
 *  @file   PI.h
 *
 *  PI.h,v 1.7 2005/11/04 09:26:55 ossama Exp
 *
 *  @author Johnny Willemsen  <jwillemsen@remedy.nl>
 */
// ===================================================================

#ifndef TAO_PI_H
#define TAO_PI_H

#include /**/ "ace/pre.h"

#include "pi_export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

#include "tao/Versioned_Namespace.h"

TAO_BEGIN_VERSIONED_NAMESPACE_DECL

/**
 * @class TAO_PI_Init
 *
 */
class TAO_PI_Export TAO_PI_Init
{
public:

  /// Used to force the initialization of the ORB code.
  static int Initializer (void);
};

static int
TAO_Requires_PI_Initializer =
  TAO_PI_Init::Initializer ();

TAO_END_VERSIONED_NAMESPACE_DECL

#include /**/ "ace/post.h"

#define TAO_PI_SAFE_INCLUDE
#include "ORBInitInfoC.h"
#include "PolicyFactoryC.h"
#include "ORBInitializerC.h"
#include "InterceptorC.h"
#include "ClientRequestInfoC.h"
#include "ClientRequestInterceptorC.h"
#include "PICurrentC.h"
#undef TAO_PI_SAFE_INCLUDE

#endif  /* TAO_PI_H */
