#include "Sender_i.h"

ACE_RCSID(Bug_1476_Regression, Sender_i, "Sender_i.cpp,v 1.1 2004/08/10 08:12:49 jwillemsen Exp")

Sender_i::Sender_i (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb)),
    active_objects_ (0),
    number_received_ (0)
{
}

Sender_i::~Sender_i (void)
{
}

void
Sender_i::active_objects (CORBA::ULong no_threads
                          ACE_ENV_ARG_DECL_NOT_USED)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->active_objects_ = no_threads;
}


void
Sender_i::send_ready_message (ACE_ENV_SINGLE_ARG_DECL_NOT_USED)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  ACE_DEBUG ((LM_DEBUG,
              "Received a call ...\n"));

  number_received_++;
}

CORBA::ULong
Sender_i::get_number_received (void) const
{
  return number_received_;
}

CORBA::ULong
Sender_i::get_active_objects (void) const
{
  return active_objects_;
}
